#include <stm32f10x_lib.h>
extern unsigned int Converted_Data;
extern unsigned int Converted_Channels[8];

void init_adc(void)
{
// Gestion Horloge
RCC->CFGR	 |= 0x0000C000;	  // PCCLK2 divis par 8 pour l'horloge des convertisseurs
RCC->APB2ENR |= (1 << 9);

// Autorisation des interruptions ADC1

NVIC->ISER[0] = 0x40000;

// Bit 31:24 Rservs
// Bit23	AWDEN = 0
// Bit22  	JAWDEN = 0
// Bit21:20 Rservs
// Bit 19:16 DUALMOD = 0
// Bit 15:13 DISCNUM = 0
// Bit 12 	JDISCEN = 0
// Bit 11 	DISCEN = 0
// Bit 10  	JAUTO = 0
// Bit 9 	AWDSGL = 0
// Bit 8 	SCAN = 0  
// Bit 7 	JEOCIE = 0
// Bit 6 	AWDIE = 0
// Bit 5 	EOCIE = 1	Autorisation interruption fin de conversion
// Bit 4:0 	AWDCH = 0

ADC1->CR1 = 0x20; // 


// Bit 31:24 Rservs
// Bit 23	TSVREFE = 0
// Bit 22  	SWSTART = 0
// Bit 21	JSWSTART = 0
// Bit 20	EXTTRIG = 0
// Bit 19:17 EXTSEL = 0
// Bit 16 	Rserv
// Bit 15	JEXTTRIG = 0
// Bit 14:12 JEXTSEL = 0
// Bit 11 	ALIGN = 0
// Bit 10:9 Rservs
// Bit 8	DMA = 0	 
// Bit 7:4	Rservs
// Bit 3	RSTCAL = 0
// Bit 2	CAL = 0
// Bit 1	CONT = 0  
// Bit 0	ADON = 1 Mise sous tension ADC ADON =1 

ADC1->CR2 = 1; 

// Base de temps de conversion

ADC1->SMPR1 = 0;
ADC1->SMPR2 = 0;

// Nombre de canaux

// Dfini le nombre de conversions (bit 23:20) et indentifie les canaux pour les conversions 16  13

ADC1->SQR1 = 0x00000000; // 

// indentifie les canaux pour les conversions 12  7

ADC1->SQR2 = 0x0;

// indentifie les canaux pour les conversions 7  1
	
ADC1->SQR3 = 0x7; 
}

void isr_adc(void)
{
int i;

ADC1-> SR = 0;  // On invalide la demande d'interruption pour avoir le temps de traiter

Converted_Data = ADC1->DR;
}




